/* GCC */
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

long long n;
vector <pair<long long,long long> > P1,P2;
vector <pair<pair<long long, long long>, long long> > L;
vector <pair<pair<long long,long long>, pair<long long,long long> > > P;
vector <pair<long long ,long long> > R;

long long gcd(long long a, long long b){
    if (a*b == 0) return a+b;
    else return ((a%b)?gcd(b,a%b):b);
}

pair <long long, long long> Dist(pair<pair<long long,long long>, pair<long long,long long> > p, pair<pair<long long, long long>, long long> l){
    long long a = l.first.first;
    long long b = l.first.second;
    long long c = l.second;
    long long xc = p.first.first;
    long long xz = p.first.second;
    long long yc = p.second.first;
    long long yz = p.second.second;

    long long cc = labs (a*xc*yz + b*xz*yc + c*xz*yz);
    long long zz = xz*yz* (long long)(sqrt(a*a + b*b) + 0.1);
    return (make_pair(cc/gcd(labs(cc),labs(zz)), zz/gcd(labs(cc), labs(zz))));
}

pair<long long,long long> Add(pair<long long,long long> q, pair<long long,long long> w){
    long long cc = q.first*w.second + q.second*w.first;
    long long zz = q.second*w.second;
    return (make_pair(cc/gcd(labs(cc), labs(zz)), zz/gcd(labs(cc), labs(zz))));
}

void PrintX(pair <long long,long long> x){
    printf("%I64d", x.first);
    if (x.second != 1) printf("/%I64d", x.second);
}

void PrintP(pair<pair<long long,long long>, pair<long long,long long> > p){
    PrintX(p.first);
    printf(" ");
    PrintX(p.second);
    printf("\n");
}

int main(){
    freopen("motel.in", "r", stdin);
    freopen("motel.out", "w", stdout);
    scanf("%I64d", &n);
    long long x1,x2,y1,y2,a,b,c,g;
    for (long long i=0; i<n; i++){
        scanf("%I64d%I64d%I64d%I64d", &x1, &y1, &x2, &y2);
        P1.push_back(make_pair(x1,y1));
        P2.push_back(make_pair(x2,y2));
        a = y2 - y1;
        b = x1 - x2;
        c = -a*x1 - b*y1;
        g = gcd(gcd(labs(a),labs(b)),labs(c));
        a = a/g;
        b = b/g;
        c = c/g;
        if ((a<0)||(a == 0 && b < 0)){a = -a; b = -b; c = -c;}
        L.push_back(make_pair(make_pair(a, b), c));
    }
    for (long long i=0; i<n; i++){
        for (long long j=i+1; j<n; j++){
            long long a1 = L[i].first.first;
            long long b1 = L[i].first.second;
            long long c1 = L[i].second;
            long long a2 = L[j].first.first;
            long long b2 = L[j].first.second;
            long long c2 = L[j].second;
            if (a1*b2 == a2*b1) continue;

            long long yc = a1*c2 - a2*c1;;
            long long yz = a2*b1 - a1*b2;
            long long d = gcd(labs(yc), labs(yz));
            yc /= d; yz /= d;
            if (yz<0) {yz = -yz; yc = -yc;}

            long long xc = b1*c2 - b2*c1;;
            long long xz = b2*a1 - b1*a2;
            d = gcd(labs(xc), labs(xz));
            xc /= d; xz /= d;
            if (xz<0) {xz = -xz; xc = -xc;}

            P.push_back(make_pair(make_pair(xc,xz), make_pair(yc,yz)));
        }
    }

    sort(P.begin(), P.end());
    P.erase(unique(P.begin(), P.end()), P.end());

    bool lines = false;
    if (P.empty()){
        lines = true;
        for (int i=0; i<n; i++) P.push_back(make_pair(make_pair(P1[i].first, 1), make_pair(P1[i].second, 1)));
    }

    for (long long i=0; i<P.size(); i++){
        R.push_back(make_pair(0,1));
        for (long long j=0; j<n; j++){
            R.back() = Add(R.back(), Dist(P[i], L[j]));
        }
    }

    long long t = 0, k = 0;
    for (long long i=1; i<R.size(); i++){
        if (R[i].first*R[t].second < R[i].second*R[t].first) t = i;
    }
    PrintX(R[t]); printf("\n");
    for (long long i=0; i<R.size(); i++){
        if (R[i] == R[t]) k++;
    }
    if (lines){
        printf("%I64d\n", -k);
        for (long long i=0; i<R.size(); i++){
            if (R[i] == R[t]) printf("%I64d %I64d %I64d\n", L[i].first.first, L[i].first.second, L[i].second);
        }
    }else{
        printf("%I64d\n", k);
        for (long long i=0; i<R.size(); i++){
            if (R[i] == R[t]) PrintP(P[i]);
        }
    }


    fclose(stdin);
    fclose(stdout);
    return 0;
}
