/* GCC */
#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long double ld;

const int MAX=11;
const ld EPS=1e-9;

int gcd(int a, int b)
{
    while(b)
    {
        a%=b;
        swap(a, b);
    }
    return a;
}

struct fraction
{
    int up, down;
    fraction() {}
    fraction(int a, int b)
    {
        int tmp=gcd(a, b);
        up=a/tmp, down=b/tmp;
        if(down<0)
        {
            up=-up;
            down=-down;
        }
    }
    operator ld()
    {
        return ld(up)/ld(down);
    }
    bool operator ==(fraction f)
    {
        return up==f.up&&down==f.down;
    }
    out()
    {
        if(up==0) cout << 0;
        else if(down==1) cout << up;
        else cout << up << '/' << down;
    }
};

struct dot_int
{
    int x, y;
    dot_int() {}
};

struct dot_fraction
{
    fraction x, y;
    int p, q;
    dot() {}
    bool operator == (dot_fraction d)
    {
        return x==d.x&&y==d.y;
    }
};

int det(int a, int b, int c, int d)
{
    return a*d-b*c;
}

struct line
{
    int a, b, c;
    int p;
    line() {}
    line(int x, int y, int z): a(x), b(y), c(z) {}
    line(dot_int u, dot_int v)
    {
        a=v.y-u.y;
        b=u.x-v.x;
        c=-b*u.y+a*u.x;
        int tmp=gcd(abs(a), abs(b));
        tmp=gcd(tmp, abs(c));
        a/=tmp, b/=tmp, c/=tmp;
        if(a<0||(a==0&&b<0))
        {
            a=-a;
            b=-b;
            c=-c;
        }
    }
};

bool parallel(line u, line v)
{
    return det(u.a, v.a, u.b, v.b)==0;
}

dot_fraction intersect(line u, line v)
{
    dot_fraction ret;
    ret.x=fraction(-det(u.c, v.c, u.b, v.b), det(u.a, v.a, u.b, v.b));
    ret.y=fraction(-det(u.a, v.a, u.c, v.c), det(u.a, v.a, u.b, v.b));
    return ret;
}

ld d(dot_fraction d, line l)
{
    ld x=d.x, y=d.y;
    return abs(0.0+l.a*x+l.b*y+l.c)/sqrt(l.a*l.a+l.b*l.b);
}

bool cmp(dot_fraction u, dot_fraction v)
{
    return u.p<v.p||(u.p==v.p&&u.q<v.q);
}

int n;
ld mn=1e9+1;
bool use[MAX];
line arr[MAX];
vector <dot_fraction> all, only, small;

int main()
{
    ios::sync_with_stdio(0);
    freopen("motel.in", "r", stdin);
    freopen("motel.out", "w", stdout);
    cin >> n;
    for(int i=0; i<n; ++i)
    {
        dot_int u, v;
        cin >> u.x >> u.y >> v.x >> v.y;
        arr[i]=line(u, v);
    }
    for(int i=0; i<n; ++i)
        for(int j=i+1; j<n; ++j)
            if(!parallel(arr[i], arr[j]))
            {
                dot_fraction tmp=intersect(arr[i], arr[j]);
                tmp.p=i, tmp.q=j;
                all.push_back(tmp);
            }

    if(all.size())
    {
        for(int i=0; i<all.size(); ++i)
            for(int j=i+1; j<all.size(); ++j)
                if(all[i]==all[j])
                    use[j]=true;
        for(int i=0; i<all.size(); ++i)
            if(!use[i])
                only.push_back(all[i]);
        for(int i=0; i<only.size(); ++i)
        {
            ld now=0;
            for(int j=0; j<n; ++j)
                now+=d(only[i], arr[j]);
            if(now<mn)
            {
                small.clear();
                small.push_back(only[i]);
                mn=now;
            }
            else if(abs(now-mn)<EPS)
                small.push_back(only[i]);
        }
        cout << mn << endl;
        cout << small.size() << endl;
        sort(small.begin(), small.end(), cmp);
        for(int i=0; i<small.size(); ++i)
        {
            small[i].x.out();
            cout << " ";
            small[i].y.out();
            if(i!=small.size()-1)
                cout << " ";
        }
        cout << endl;
    }
    else
    {

    }
    return 0;
}
